#include <stdlib.h>
#include <stdio.h>
#include "palette.h"

int
main (void)
{
    const int row = 16;
    const int mult = 8;

    int i, j, k, l;
    FILE *cid;

    cid = fopen ("palette.xpm", "w");
    if (!cid)
	exit (printf ("\nError: impossible to create file \"palette.xpm\""));
    fputs ("/* XPM */\n\n", cid);
    fputs ("/* generated by genpal\n", cid);
    fputs (" * written by Marcello Sega (2002) */\n", cid);
    fputs ("static char * palette[] = {\n", cid);
    fprintf (cid, "\"%d %d %d %d\",\n", row * mult, row * mult, 256, 3);
    for (i = 0; i < 256; i++)
    {
	fprintf (cid, "\"%.3d c #%.2x%.2x%.2x\",\n", i, palette[3 * i],
		 palette[3 * i + 1], palette[3 * i + 2]);
    }

    for (i = 0; i < row; i++)
    {
	for (k = 0; k < mult; k++)
	    for (j = 0; j < row; j++)
	    {
		if (j == 0)
		    fprintf (cid, "\"");
		for (l = 0; l < mult; l++)
		    fprintf (cid, "%.3d", 16 * i + j);
		if (j == row - 1)
		    fprintf (cid, "\",\n");
	    }
    }
    fseek (cid, -2, SEEK_CUR);
    fputs ("};\n", cid);
    fclose (cid);
    return 0;
}
